package com.base.locationsharewhite.location

import android.os.Build
import com.base.locationsharewhite.BuildConfig
import com.base.locationsharewhite.bean.ViewerBean
import com.base.locationsharewhite.bean.ViewingBean
import com.base.locationsharewhite.helper.AESHelper
import com.base.locationsharewhite.helper.ConfigHelper
import com.base.locationsharewhite.helper.ReportUtils
import com.base.locationsharewhite.utils.AppPreferences
import com.base.locationsharewhite.utils.LogEx
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import org.json.JSONObject
import java.lang.reflect.Type


/**
 * 获取分享关系列表
 */
object LocationShareListUtils {

    private val TAG = "LocationShareListUtils"

    /**
     * 分享关系列表
     */
    private val url by lazy {
        val pkg = ConfigHelper.packageName
        val url = StringBuilder(
            "${ConfigHelper.apiUrl}/dingwei/${pkg.filter { it.isLowerCase() }.substring(4, 9)}ac"
        )
        url.append("?pkg=$pkg")
        url.toString()
    }

    fun getShareList(
        viewerListCallBack: ((viewerList: List<ViewerBean>) -> Unit)? = null,
        viewingListCallBack: ((viewingList: List<ViewingBean>) -> Unit)? = null
    ) {
        Thread {
            val pkg = ConfigHelper.packageName

            val data = JSONObject()
            val bp = JSONObject()
//            .put("${pkg}_1", "")
                .put("${pkg}_5", Build.VERSION.SDK_INT)
                .put("${pkg}_8", BuildConfig.VERSION_NAME)
                .put("${pkg}_9", AppPreferences.getInstance().getString("uuid", ""))
                .put("${pkg}_10", AppPreferences.getInstance().getString("uuid", ""))//gid
                .put("${pkg}_13", "android")
                .put("${pkg}_14", BuildConfig.VERSION_CODE)
                .put("${pkg}_15", "google")
                .put("${pkg}_24", BuildConfig.BUILD_TYPE)
            val body = JSONObject()
                .put("data", data)
                .put("bp", bp)
                .toString()
            LogEx.logDebug(TAG, "uuid=${AppPreferences.getInstance().getString("uuid", "")}")
            val paramJson = AESHelper.encrypt(body)
            runCatching {
                val result = ReportUtils.doPost(url, HashMap(), paramJson)
                LogEx.logDebug(TAG, "result=$result")
                val responseData = LocationLoginUtils.extractData(result)
                LogEx.logDebug(TAG, "responseData=$responseData")
                if (responseData != null) {
                    val decryptedData = AESHelper.decrypt(responseData)
                    LogEx.logDebug(TAG, "decryptedData=$decryptedData")
                    parseShareListData(decryptedData, viewerListCallBack, viewingListCallBack)
                }
            }
        }.start()
    }

    private fun parseShareListData(
        decryptedData: String,
        viewerListCallBack: ((viewerList: List<ViewerBean>) -> Unit)? = null,
        viewingListCallBack: ((viewingList: List<ViewingBean>) -> Unit)? = null
    ) {
        val gson = Gson()
        val viewerListType: Type = object : TypeToken<List<ViewerBean>>() {}.type
        val viewingListType: Type = object : TypeToken<List<ViewingBean>>() {}.type

        val jsonObject = JSONObject(decryptedData)

        val viewerListJson = jsonObject.getJSONArray("viewerList").toString()
        LogEx.logDebug(TAG, "viewerListJson=$viewerListJson")
        val viewerList: List<ViewerBean> = gson.fromJson(viewerListJson, viewerListType)
        viewerListCallBack?.invoke(viewerList)

        val viewingListJson = jsonObject.getJSONArray("viewingList").toString()
        LogEx.logDebug(TAG, "viewingListJson=$viewingListJson")
        val viewingList: List<ViewingBean> = gson.fromJson(viewingListJson, viewingListType)
        viewingListCallBack?.invoke(viewingList)
    }
}